package frontend

import (
	"html/template"
	"net/http"

	b "streifling.com/jason/cpolis/cmd/backend"
)

func CreateTag(c *b.Config, s *b.CookieStore) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		if _, err := getSession(w, r, c, s); err != nil {
			return
		}

		tmpl, err := template.ParseFiles(c.WebDir + "/templates/add-tag.html")
		template.Must(tmpl, err).ExecuteTemplate(w, "page-content", nil)
	}
}

func AddTag(c *b.Config, db *b.DB, s *b.CookieStore) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		session, err := getSession(w, r, c, s)
		if err != nil {
			return
		}

		db.AddTag(r.PostFormValue("tag"))

		tmpl, err := template.ParseFiles(c.WebDir + "/templates/hub.html")
		tmpl = template.Must(tmpl, err)
		tmpl.ExecuteTemplate(w, "page-content", session.Values["role"])
	}
}
